#!/usr/bin/perl -w

# Convert mp3 data to 16-bit, backward-endian table data for PIC18 devices.
# NOTE: mp3 data should have an even number of bytes! Otherwise, one garbage byte will be stored at the end of the table as padding...
# This is for built-into-PIC test data only; actual mp3 data/frames sent from the external device won't have this restriction.

($tablename, $junk)=split(/\./, @ARGV[0]); # Get the first part of the filename (without ".mp3")


open INFILE, "< $ARGV[0]" or die "Couldn't open INFILE: $!\n"; 
open OUTFILE, "> $tablename.inc" or die "Couldn't open OUTFILE: $!\n";
binmode(INFILE);

$count = 0;

printf OUTFILE "; \$Id: \$\n\n; MP3 data table (backward-endian) generated by mp32table.pl\n";

printf OUTFILE "; Input file name was $ARGV[0].\n\n";
printf OUTFILE "$tablename:\n";


# Fuck, swapped the data lines. Unfucking them in software... HACK HACK HACK



while (read(INFILE, $buff, 2)) 
{
	($one, $two) = split(//, $buff);
	#$one=&flipbyte($one);
	#$two=&flipbyte($two);
	printf OUTFILE ("\tDW H'%02X%02X'\n", &flipbyte(ord($two)), &flipbyte(ord($one)));
	printf ("\tDW H'%02X%02X'\n", ord($two), ord($one));
	$count++;
}

print "Total $count lines ";
print OUTFILE "\n; Total $count lines\n";

$count = $count * 2;
print " ($count bytes)\n";
print OUTFILE "; ($count bytes)\n";


close(INFILE);
close(OUTFILE);


sub flipbyte {
	my ($byte)=@_;

	#print ord($byte);

	$bit7 = ($byte & 0x80) >> 7;
	$bit6 = ($byte & 0x40) >> 6;
	$bit5 = ($byte & 0x20) >> 5;
	$bit4 = ($byte & 0x10) >> 4;
	$bit3 = ($byte & 0x08) >> 3;
	$bit2 = ($byte & 0x04) >> 2;
	$bit1 = ($byte & 0x02) >> 1;
	$bit0 = ($byte & 0x01);

	return (128*$bit0 + 64*$bit1 + 32*$bit2 + 16*$bit3 + 8*$bit4 + 4*$bit5 + 2*$bit6 + $bit7);


}
